<template>
  <ai-list class="notice">
    <template slot="title">
      <ai-title title="内容管理" isShowBottomBorder></ai-title>
    </template>
    <template slot="content">
      <ai-search-bar class="search-bar">
        <template #left>
          <el-button size="small" type="primary" icon="iconfont iconAdd" @click="toAdd('')">添加模块</el-button>
        </template>
      </ai-search-bar>
      <ai-table
        :tableData="tableData"
        :col-configs="colConfigs"
        :total="total"
        style="margin-top: 6px;"
        :current.sync="search.current"
        :size.sync="search.size"
        @getList="getList">
        <el-table-column slot="options" width="220px" fixed="right" label="操作" align="center">
          <template slot-scope="{ row }">
            <div class="table-options">
              <el-button type="text" @click="toAdd(row.id)">编辑</el-button>
              <el-button type="text" @click="moduleId = row.id, form.moduleId = row.id, getCateList(),  isShowAdd = true">分类</el-button>
              <el-button type="text" @click="remove(row.id)">删除</el-button>
            </div>
          </template>
        </el-table-column>
      </ai-table>
      <ai-dialog
        :visible.sync="isShowAdd"
        width="880px"
        height="580px"
        title="文章分类"
        @close="onClose"
        @onConfirm="onConfirm(false)">
        <el-form ref="form" class="ai-form" :model="form" label-width="110px" label-position="right">
          <el-form-item label="分类名称" style="width: 500px;" prop="categoryName" :rules="[{ required: true, message: '请输入分类名称', trigger: 'blur' }]">
            <div class="catewrapper">
              <el-input  size="small" style="width: 300px;" placeholder="请输入分类名称" v-model="form.categoryName">
              </el-input>
              <el-button style="margin-left: 20px;" size="small" type="primary" icon="iconfont iconAdd" v-if="!id" @click="onConfirm(true)">添加</el-button>
            </div>
          </el-form-item>
        </el-form>
        <ai-table
          v-if="!id"
          class="detail-table__table"
          :border="true"
          tableSize="small"
          :total="cateTotal"
          :tableData="cateList"
          :col-configs="cateColConfigs"
          :current.sync="cateSearch.current"
          :size.sync="cateSearch.size"
          :stripe="false"
          @getList="getCateList">
          <el-table-column slot="options" width="220px" fixed="right" label="操作" align="center">
            <template slot-scope="{ row }">
              <div class="table-options">
                <el-button type="text" @click="id = row.id, form.categoryName = row.categoryName">编辑</el-button>
                <el-button type="text" @click="removeCate(row.id)">删除</el-button>
              </div>
            </template>
          </el-table-column>
        </ai-table>
      </ai-dialog>
    </template>
  </ai-list>
</template>

<script>
  export default {
    name: 'List',

    props: {
      instance: Function,
      dict: Object
    },

    data() {
      return {
        search: {
          current: 1,
          size: 10,
          title: ''
        },
        moduleId: '',
        cateSearch: {
          current: 1,
          size: 10
        },
        total: 10,
        cateList: [],
        colConfigs: [
          { prop: 'moduleName',  label: '模块名称', align: 'left', width: '200px' },
          { prop: 'menuName', label: '关联菜单', align: 'center' },
          { prop: 'categoryStr', label: '文章分类', align: 'center' }
        ],
        cateColConfigs: [
          {prop: 'categoryName', label: '分类名称', align: 'center'}
        ],
        form: {
          categoryName: '',
          moduleId: '',
          showIndex: 1
        },
        cateTotal: 0,
        isShowAdd: false,
        id: '',
        tableData: []
      }
    },

    mounted() {
      this.getList()
    },

    methods: {
      getList() {
        this.instance.post(`/app/appcontentmoduleinfo/list`, null, {
          params: {
            ...this.search
          }
        }).then(res => {
          if (res.code == 0) {
            this.tableData = res.data.records
            this.total = res.data.total
          }
        })
      },

      getCateList () {
        this.instance.post(`/app/appcontentmodulecategory/list`, null, {
          params: {
            ...this.cateSearch,
            moduleId: this.moduleId
          }
        }).then(res => {
          if (res.code == 0) {
            this.cateList = res.data.records
            this.cateTotal = res.data.total
          }
        })
      },

      removeCate(id) {
        this.$confirm('确定删除该数据？').then(() => {
          this.instance.post(`/app/appcontentmodulecategory/delete?ids=${id}`).then(res => {
            if (res.code == 0) {
              this.$message.success('删除成功！')
              this.getList()
              this.getCateList()
            }
          })
        })
      },

      remove(id) {
        this.$confirm('确定删除该数据？').then(() => {
          this.instance.post(`/app/appcontentmoduleinfo/delete?ids=${id}`).then(res => {
            if (res.code == 0) {
              this.$message.success('删除成功！')
              this.getList()
            }
          })
        })
      },

      onConfirm (flag) {
        if (!flag && !this.id) {
          this.isShowAdd = false

          return false
        }

        this.$refs.form.validate((valid) => {
          if (valid) {
            this.instance.post(`/app/appcontentmodulecategory/addOrUpdate`, {
              ...this.form,
              id: this.id || ''
            }).then(res => {
              if (res.code == 0) {
                this.$message.success('提交成功')
                this.getList()
                this.getCateList()
                this.form.categoryName = ''

                if (this.id) {
                  this.id = ''

                  return false
                }
              }
            })
          }
        })
      },

      onClose () {
        this.id = ''
        this.moduleId = ''
        this.form.categoryName = ''
        this.form.moduleId = ''
      },

      toAdd(id) {
        this.$emit('change', {
          type: 'Add',
          params: {
            id: id || ''
          }
        })
      }
    }
  }
</script>

<style lang="scss" scoped>
  .notice {
    .catewrapper {
      display: flex;
      align-items: center;
    }
  }
</style>
